<template>
  <section class="how-it-works">

    <template v-if="!isMobile">
      <first-step-bg v-if="step === 0"></first-step-bg>
      <second-step-bg v-if="step === 1"></second-step-bg>
      <third-step-bg v-if="step === 2"></third-step-bg>
    </template>

    <div class="container" v-if="!isMobile">
      <h2 class="how-it-works__title">Как это работает</h2>

      <ol class="how-it-works__head">
        <li v-for="(item, index) in steps" :key="item"
            class="how-it-works__head-item"
            :class="{'active ': index === step}"
            @click="changeStep(index)"
        >
          <span class="how-it-works__head-counter">{{ index + 1 }}</span>
          <span class="how-it-works__head-text">{{ item }}</span>
        </li>
      </ol>

      <div class="how-it-works__body">

        <p class="how-it-works__text" v-if="step === 0">
          Для начала найдите подходящее помещение в нашем
          <nuxt-link to="/places">каталоге</nuxt-link>.
          Самый простой способ сделать это — выбрать нужный тип помещения и ближайшее метро.
          <br><br>
          Также вы можете применить такие фильтры, как: дата, время, вместимость.
        </p>

        <p class="how-it-works__text" v-if="step === 1">
          Как только вы выбрали нужное помещение — <b>забронируйте его</b>.
          Выберите удобную дату, время и заполните необходимую информацию.
          <br><br>
          <b>Затем укажите удобный способ оплаты</b>.
          Вы можете оплатить аренду при помощи банковской карты или внутреннего счета.
        </p>

        <p class="how-it-works__text" v-if="step === 2">
          После успешной оплаты в самое ближайшее время вам придет
          <b>уведомление с подтверждением бронирования помещения</b>, его адресом и контактами.
        </p>

        <nuxt-link to="/places"
                   class="button button--green how-it-works__btn">
          Выбрать помещение
        </nuxt-link>

      </div>
    </div>

    <template v-else>
      <div class="container">
        <ol class="how-it-works__head">
          <li v-for="(item, index) in steps" :key="item"
              class="how-it-works__head-item"
              :class="{'active ': index === step}"
              @click="changeStep(index)"
          >
            <span class="how-it-works__head-counter">{{ index + 1 }}</span>
            <span class="how-it-works__head-text">{{ item }}</span>
          </li>
        </ol>
      </div>

      <swiper :options="swiperOptions"
              class="how-it-works__body"
              ref="worksSlider"
      >

        <swiper-slide class="how-it-works__slide"
                      :style="{'background-image': isMobile ? `url(/images/hiw-bg-0.png)` : ``}"
        >
          <p class="how-it-works__text" v-if="step === 0">
            Для начала найдите подходящее помещение в нашем
            <nuxt-link to="/places">каталоге</nuxt-link>.
            Самый простой способ сделать это — выбрать нужный тип помещения и ближайшее метро.
            <br><br>
            Также вы можете применить такие фильтры, как: дата, время, вместимость.
          </p>

          <nuxt-link to="/places"
                     class="button button--green how-it-works__btn">
            Выбрать помещение
          </nuxt-link>
        </swiper-slide>

        <swiper-slide class="how-it-works__slide"
                      :style="{'background-image': isMobile ? `url(/images/hiw-bg-1.png)` : ``}"
        >
          <p class="how-it-works__text" v-if="step === 1">
            Как только вы выбрали нужное помещение — <b>забронируйте его</b>.
            Выберите удобную дату, время и заполните необходимую информацию.
            <br><br>
            <b>Затем укажите удобный способ оплаты</b>.
            Вы можете оплатить аренду при помощи банковской карты или внутреннего счета.
          </p>

          <nuxt-link to="/places"
                     class="button button--green how-it-works__btn">
            Выбрать помещение
          </nuxt-link>
        </swiper-slide>

        <swiper-slide class="how-it-works__slide how-it-works__slide--third"
                      :style="{'background-image': isMobile ? `url(/images/hiw-bg-2.png)` : ``}"
        >
          <p class="how-it-works__text" v-if="step === 2">
            После успешной оплаты в самое ближайшее время вам придет
            <b>уведомление с подтверждением бронирования помещения</b>, его адресом и контактами.
          </p>

          <nuxt-link to="/places"
                     class="button button--green how-it-works__btn how-it-works__btn--third">
            Выбрать помещение
          </nuxt-link>
        </swiper-slide>

      </swiper>


    </template>
  </section>
</template>

<script>
  import FirstStepBg from './working-steps/FirstStepBg';
  import SecondStepBg from './working-steps/SecondStepBg';
  import ThirdStepBg from './working-steps/ThirdStepBg';

  export default {
    name: 'HowItWorks',
    components: {
      ThirdStepBg,
      SecondStepBg,
      FirstStepBg
    },
    data: () => ({
      step: 0,
      steps: [
        'Выбор помещения',
        'Бронирование и оплата',
        'Использование',
      ],
      swiperOptions: {
        spaceBetween: 0,
        resistanceRatio: 0
      },
      swiperApi: null
    }),
    mounted() {
      this.initSwiper();
    },
    watch: {
      step(val) {
        if (!this.isMobile) return;
        this.swiperApi.slideTo(val);
      },

      isMobile() {
        this.initSwiper();
      }
    },
    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      }
    },
    methods: {
      changeStep(step) {
        this.step = step;
      },

      initSwiper() {
        this.$nextTick(() => {
          if (!this.isMobile) return;

          this.swiperApi = this.$refs.worksSlider.$swiper;

          this.swiperApi.on('slideChange', () =>
            this.step = this.swiperApi.activeIndex
          );
        })
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .how-it-works {
    position: relative;

    max-width: rem(1440);
    margin: 0 auto;
    padding: rem(80) 0 rem(96);

    box-shadow: inset 0 0 rem(80) rem(80) $gray;
    overflow: hidden;

    @media (max-width: $mobile-width) {
      display: flex;
      flex-direction: column;

      height: calc(100vh - 2rem);
      padding: rem(48) 0 0;

      box-shadow: inset 0 rem(-40) rem(40) $gray;
    }

    svg {
      position: absolute;
      z-index: -1;

      top: 0;
      left: 0;
      right: 0;
      bottom: 0;

      width: 100%;
      height: 100%;
    }

    &__title {
      @include h3;
      margin-bottom: rem(60);
    }

    &__head {
      display: flex;
      margin-bottom: rem(50);

      @media (max-width: $mobile-width) {
        margin-bottom: rem(30);
      }
    }

    &__head-counter {
      @include gray-btn;

      content: counter(myCounter);

      display: flex;
      align-items: center;
      justify-content: center;

      flex: 0 0 rem(40);
      width: rem(40);
      height: rem(40);
      margin-right: rem(20);

      color: rgba($black, .3);

      border-radius: 50%;
    }

    &__head-item {
      display: flex;
      align-items: center;
      flex: 0 0 rem(398);
      width: rem(398);

      @include p1;
      color: rgba($black, .5);

      cursor: pointer;

      &:last-child {
        flex: 1 1 auto;
        width: auto;
      }

      &.active {
        .how-it-works__head-counter {
          @include green-btn;

          color: $white;
        }

        color: $green;
      }

      @media (max-width: $mobile-width) {
        flex: 0 0 auto;
        width: rem(40);

        transition: all .5s;

        & + & {
          margin-left: rem(8);
        }

        .how-it-works__head-text {
          display: none;
        }

        &.active {
          width: calc(100% - 6rem);

          .how-it-works__head-text {
            display: block;
          }
        }
      }
    }

    &__head-text {
      @media (max-width: $mobile-width) {
        white-space: nowrap;
      }
    }

    &__body {
      display: flex;
      flex-flow: column;
      align-items: flex-start;

      @media (max-width: $mobile-width) {
        flex: 1;
        width: 100%;
      }
    }

    &__slide {
      @media (max-width: $mobile-width) {
        padding: 0 rem(20);

        background-position: center calc(100% + 1.25rem);
        background-repeat: no-repeat;
        background-size: cover;

        &--third {
          background-position: center calc(100% + 2.5rem);
        }
      }
    }

    &__text {
      max-width: rem(495);

      @include p2;

      a {
        color: $green;
      }

      b {
        color: $black;
      }
    }

    &__btn {
      margin-top: rem(50);

      @media (max-width: $mobile-width) {
        width: rem(244);
        margin-top: rem(20);

        &--third {
          position: absolute;

          /*width: rem(244);*/
          bottom: rem(280);
          left: rem(68);
        }
      }
    }
  }
</style>
